Bug 1005931 - Review Request: dynalink - Dynamic Linker Framework for Languages on the JVM
Review Request: dynalink - Dynamic Linker Framework for Languages on the JVM
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michael Simacek
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1005932
  Show dependency treegraph
 
Reported: 2013-09-09 13:28 EDT by gil cattaneo
Modified: 2013-12-13 22:00 EST (History)
1 user (show)

See Also:
Fixed In Version: dynalink-0.7-3.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-12-13 22:00:44 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
msimacek: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description gil cattaneo 2013-09-09 13:28:26 EDT
Spec URL: http://gil.fedorapeople.org/dynalink.spec
SRPM URL: http://gil.fedorapeople.org/dynalink-0.7-1.fc19.src.rpm
Description:
Dynalink is an invoke-dynamic-based high-level linking and
meta-object protocol library. It enables creation of
languages on the JVM that can easily inter-operate with
plain Java objects and each other.
Fedora Account System Username: gil
Comment 1 Michael Simacek 2013-11-11 06:28:47 EST
I'll do the review
Comment 2 Michael Simacek 2013-11-11 08:54:33 EST
Some minor issues:
- BuildRequires: java-devel is unnecessary, it gets added automatically
  as a dependecy of maven-local
- %mvn_file belongs to %prep
- dual licensing - see below

Other than that it looks good

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "BSD (2 clause)", "Unknown or generated". 5 files have unknown license.
[x]: License file installed when any subpackage combination is installed.
[!]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
     The duality of license should be stated explicitly in a comment and it
     should use 'or' as a separator instead of 'and'. See:
     http://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Dual_Licensing_Scenarios
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It is
     pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
[x]: Bundled jar/class files should be removed before build

Maven:
[x]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Pom files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in dynalink-
     javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: dynalink-0.7-1.fc19.noarch.rpm
          dynalink-javadoc-0.7-1.fc19.noarch.rpm
          dynalink-0.7-1.fc19.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint dynalink dynalink-javadoc
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
dynalink (rpmlib, GLIBC filtered):
    java
    jpackage-utils
    mvn(org.ow2.asm:asm)

dynalink-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils



Provides
--------
dynalink:
    dynalink
    mvn(org.dynalang:dynalink)

dynalink-javadoc:
    dynalink-javadoc



Source checksums
----------------
https://github.com/szegedi/dynalink/archive/0.7.tar.gz :
  CHECKSUM(SHA256) this package     : 92369ccba18f4cdcda3c363c991a84d9e079688f329a3166bcc214251a0bb1cc
  CHECKSUM(SHA256) upstream package : 92369ccba18f4cdcda3c363c991a84d9e079688f329a3166bcc214251a0bb1cc


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1005931
Buildroot used: fedora-19-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 3 gil cattaneo 2013-11-11 09:29:12 EST
Spec URL: http://gil.fedorapeople.org/dynalink.spec
SRPM URL: http://gil.fedorapeople.org/dynalink-0.7-2.fc19.src.rpm

- fix license field
- remove unnecessary BR java-devel
Comment 4 gil cattaneo 2013-11-11 20:46:04 EST
New Package SCM Request
=======================
Package Name: dynalink
Short Description: Dynamic Linker Framework for Languages on the JVM
Owners: gil
Branches: f20
InitialCC: java-sig
Comment 5 Gwyn Ciesla 2013-11-12 08:14:56 EST
I'm a bit unclean as to whether the reviewer actually approved this, since
the submitter set the review flag.  Reviewer, please clarify.  Thanks!
Comment 6 Michael Simacek 2013-11-12 11:22:35 EST
No you can't approve it yourself.

There's another problem that I didn't encounter before, because I wasn't building it in Koji. It's build fails on ARM and maybe some other arches, because it uses some JDK features, that are not completely implemented on it (or buggy).
See: http://kojipkgs.fedoraproject.org//work/tasks/262/6170262/build.log

Therefore, it shouldn't be noarch and should exclude ARM (and possibly other arches it doesn't build on)

Btw. once again - %mvn_file belongs to %prep section (http://fedoraproject.org/wiki/Packaging:Java#Alternative_JAR_file_names)
Comment 7 gil cattaneo 2013-11-12 11:41:46 EST
(In reply to Michael Simacek from comment #6)
> No you can't approve it yourself.
> 

sorry, my mistake

> There's another problem that I didn't encounter before, because I wasn't
> building it in Koji. It's build fails on ARM and maybe some other arches,
> because it uses some JDK features, that are not completely implemented on it
> (or buggy).
> See: http://kojipkgs.fedoraproject.org//work/tasks/262/6170262/build.log
> 
i think only on arm builder (i use x86, you?)
> Therefore, it shouldn't be noarch and should exclude ARM (and possibly other
> arches it doesn't build on)
> 

no this is a noarch package
see https://bugzilla.redhat.com/show_bug.cgi?id=991712
arm builder is really a crap ...
just disable test suite such as other packages ...(there is a long java packages list with the sane problem...)

> Btw. once again - %mvn_file belongs to %prep section

in some case in that section this macros don't work properly

> (http://fedoraproject.org/wiki/Packaging:Java#Alternative_JAR_file_names)

and usually this is only a suggestion
Comment 8 gil cattaneo 2013-11-12 11:56:34 EST
Spec URL: http://gil.fedorapeople.org/dynalink.spec
SRPM URL: http://gil.fedorapeople.org/dynalink-0.7-3.fc19.src.rpm

- disable test suite
Comment 9 Michael Simacek 2013-11-13 10:34:56 EST
I think disabling the test suite doesn't really solve the problem, just hide it. If you look at the stacktraces of failed tests, it mostly crashes in the application part not in the test. So if you disable tests, it will build, but it won't work on ARM anyway. Setting ExcludeArch: arm seems more appropriate. And making it arch dependent, because AFAIK ExcludeArch doesn't work on noarch packages.
Comment 10 gil cattaneo 2013-11-14 23:16:49 EST
your suggestion isn't a best solution, because, at least half of the java packages fail (test suite) on ARM builder. and these packets are all noarch
Comment 11 Michael Simacek 2013-11-25 04:05:51 EST
I think that if a package doesn't work on some architecture, it should be excluded there. But since I have no way to test if it really doesn't work on ARM or if it's just the tests, I'm leaving it up to your decision. APPROVED
Comment 12 gil cattaneo 2013-11-25 06:03:00 EST
Thanks!

New Package SCM Request
=======================
Package Name: dynalink
Short Description: Dynamic Linker Framework for Languages on the JVM
Owners: gil
Branches: f20
InitialCC: java-sig
Comment 13 Gwyn Ciesla 2013-11-25 08:18:04 EST
Git done (by process-git-requests).
Comment 14 Fedora Update System 2013-11-25 10:08:24 EST
dynalink-0.7-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/dynalink-0.7-3.fc20
Comment 15 Fedora Update System 2013-11-25 23:02:46 EST
dynalink-0.7-3.fc20 has been pushed to the Fedora 20 testing repository.
Comment 16 Fedora Update System 2013-12-13 22:00:44 EST
dynalink-0.7-3.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.